<?php
//ini_set('display_errors',1);

include 'common.php';

defined('BASEPATH') OR exit('No direct script access allowed');

class Users extends Common {

	function __construct() {

		parent::__construct();

		// Load url helper	
		$this->load->helper('url','form');
		$this->load->database();
		$this->load->model("userModel");


		$this->load->library('session');

		$this->load->library('form_validation');
		$this->load->library('email');

	}

	public function index(){
		redirect('/index.php/users/login');
	}

	

	public function login(){
		if($this->session->userdata('log_in')){
			redirect('/index.php/users/dashboard');
		}


		if($this->input->post('submit')=='Login'){

			$this->form_validation->set_rules('user_name','Email','required|valid_email');

			$this->form_validation->set_rules('user_password', 'Password', 'required');

			if($this->form_validation->run() == FALSE){

				$this->session->set_flashdata('logError', 'Invalid username or password');

				redirect('/index.php/users/login' );

			}else{

				$data['user_name']=$this->input->post('user_name');

				$data['user_password']=$this->input->post('user_password');	

				$doc=$this->userModel->login($data);

				if(is_array($doc)){

					$this->session->set_userdata('log_in',$doc);

					redirect('/index.php/users/dashboard');	

				}else{

					$this->session->set_flashdata('logError',$doc );

					redirect('/index.php/users/login' );		

				}

			}

		}else{

			$this->load->view('users/login');

		}

	}





	public function dashboard(){
		$this->isloggedin();
		$getdashboard = $this->userModel->getdashboard();
		$this->data['dashboarddetails'] = $getdashboard;
		$this->userlayout('users/dashboard');
	}

	

	public function logout() {
		$this->session->sess_destroy();
		$this->session->unset_userdata('logged_in');
		redirect('/index.php/users/login');	
	}







	public  function adduser(){

		$this->isloggedin();

		$userdata=$this->session->userdata('log_in');	

		//if($userdata[0]->user_role==1){

			if($this->input->post('submit')!='Add'){
				$this->userlayout('users/adduser');
			}else{

					$data['user_name']=$this->input->post('user_name');

					$data['user_password']=$this->input->post('user_password');

					$data['user_email']=$this->input->post('user_email');

					$this->form_validation->set_rules('user_email','Email','required|is_unique[users.user_email]|valid_email');

					if($this->form_validation->run() == FALSE){	

						$this->userlayout('users/adduser');

					}else{

						$reg=$this->userModel->reg($data);

						$this->session->set_flashdata('success', $reg);

						redirect('/index.php/users/adduser');	

					}

			}

	/*	}else{

			$this->session->set_flashdata('error', 'Only Admin can create user account.');

		} */

	}





	public function alluser(){

		$this->isloggedin();

		$users=$this->userModel->allusers();

		$this->data=array('data' => $users);

		$this->userlayout('users/alluser');

	}





	public function edituser($id){

		$userdata=$this->session->userdata('log_in');	

		$this->isloggedin();

	//	if($userdata[0]->user_role==1){

		if($this->input->post('submit')!='Update'){

			$user=$this->userModel->oneuser($id);

			$this->data=array('data' =>$user);

			$this->userlayout('users/edituser');

		}else{

			

		$data['user_email']=$this->input->post('user_email');

		$data['user_name']=$this->input->post('user_name');

		

		$this->form_validation->set_rules('user_email','Email','required|valid_email');

		$this->form_validation->set_rules('user_name', 'Username', 'required');

		if($this->form_validation->run() == FALSE){

			$user=$this->userModel->oneuser($id);

			$this->data=array('data' =>$user);

			$this->userlayout('users/edituser');

		}else{

			$reg=$this->userModel->editReg($data,$id);
			$this->session->set_flashdata('success','User has been updated successfully!!');
			redirect('/index.php/users/alluser');

			}

	}

}



	public function userdelete($id){	
		$del=$this->userModel->del($id);
		if($del=true){
			$this->session->set_flashdata('success','User has been deleted successfully!!');
			redirect('/index.php/users/alluser');
		}
	}

	

	

	public function addemaillist(){

		$this->isloggedin();

		$userdata=$this->session->userdata('log_in');	


			if($this->input->post('submit')!='Submit'){

					$this->userlayout('users/addemaillist');

			}else{

					$data['group_name']=$this->input->post('group_name');

					$data['emaillist_email']=$this->input->post('emaillist_email');

					$this->form_validation->set_rules('group_name','Group Name','required|is_unique[group.group_name]');

					$this->form_validation->set_rules('emaillist_email','Email list','required');

					if($this->form_validation->run() == FALSE){	

						$this->userlayout('users/addemaillist');

					}else{

						$res=$this->userModel->addEmail_addGroup($data);

						$this->session->set_flashdata('success', $res);

						redirect('/index.php/users/addemaillist');	

				}

			}

		

	}

	

	

	public function allemaillist(){

		$this->isloggedin();

		$groups=$this->userModel->allGroup();

		$this->data=array('lists' =>$groups);

		$this->userlayout('users/allemaillist');



		

		}



	public function allemail($id){
		$this->isloggedin();
		$emails=$this->userModel->allemail_list($id);
		$this->data=array('emails' =>$emails);
		$this->userlayout('users/allemail');
	}

	

	public function emailListdelete($id){

		$del=$this->userModel->emailList_del($id);

		if($del=true){

			redirect('/index.php/users/allemaillist');

		}

		}

	







	public function addmedia(){
		$this->isloggedin();
		$userdata=$this->session->userdata('log_in');	
		if($this->input->post('submit')!='Submit'){
			$this->userlayout('users/addmedia');
		}else{
			$config = array(
				'upload_path' =>"./uploads/",
				'allowed_types' => "gif|jpg|png|jpeg|pdf",
				'overwrite' => TRUE,
				'max_size' => "2048000", // Can be set to particular file size , here it is 2 MB(2048 Kb)
				'max_height' => "768",
				'max_width' => "1024"
			);

			$this->load->library('upload', $config);
			if(!$this->upload->do_upload('media_file')){
				$error=array('error'=> $this->upload->display_errors());
				$this->session->set_flashdata('error',$error);
				redirect('/index.php/users/addmedia');			
			}else{
				$data['media_title']=$this->input->post('media_title');
				$imgdata = array('upload_data' => $this->upload->data());
				$data['media_path']=$imgdata['upload_data']['file_name'];
			}

			$this->form_validation->set_rules('media_title','media title','required|is_unique[media.media_title]');
			if($this->form_validation->run() == FALSE){	
				$this->userlayout('users/addmedia');
			}else{
				$res=$this->userModel->addMedia($data);
				$this->session->set_flashdata('success', $res);
				redirect('/index.php/users/addmedia');	
			}
		}
	}



	public function media( ){ // this method use for popup from
		
		$config = array(
			'upload_path' =>"./uploads/",
			'allowed_types' => "gif|jpg|png|jpeg|pdf",
			'overwrite' => TRUE,
			'max_size' => "2048000", // Can be set to particular file size , here it is 2 MB(2048 Kb)
			'max_height' => "768",
			'max_width' => "1024"
		);
		
		$this->load->library('upload', $config);
			if(!$this->upload->do_upload('media_file')){
				echo"Select image";
			}else{
				$data['media_title']=$_POST['media_title'];
				$imgdata = array('upload_data' => $this->upload->data());
				$data['media_path']=$imgdata['upload_data']['file_name'];
				$res=$this->userModel->addMedia($data);
				if($res!=''){
					echo $data['media_path'];
				}else{
					echo"error";
				}
		}	
	}


	public function  allmedia(){

		$this->isloggedin();

		$medias=$this->userModel->allmedia();

		$this->data=array('medias'=>$medias);

		$this->userlayout('users/allmedia');
		
	}	

		/*public function  allMedia(){
		$this->isloggedin();
		$medias=$this->user_model->allmedia();
		$this->data=array('medias'=>$medias);
		$this->userlayout('users/allMedia');

		}	*/
		
		
		
		public function loadModal(){
			$allMedia = $this->userModel->allmedia();
			echo '<table class="table table-hover" id="dataTables_media">
			<tr class="active">
			<th class="col-sm-1">#</th>
			<th>Title</th>
			<th>Media</th>
			<th>Action</th>
			</tr>';
			for( $i=0; $i<count($allMedia); $i++ ){ ?>
			<tr>
			<td>#</td>
			<td><?php  echo $allMedia[$i]->media_title; ?></td>
			<td><img id="img_<?php echo $allMedia[$i]->media_id ?>"   style="height:80px; width: 100px"  src="<?php  echo base_url().'/uploads/'.$allMedia[$i]->media_path; ?>"  /></td>
			<td><button class="btn btn-primary btn-sm" onclick="useMedia('<?php  echo base_url().'/uploads/'.$allMedia[$i]->media_path; ?> ')">Use</button></td>
			</tr>
			<?php 		 }
			echo'</table>';
		}	
		
		

		public function addtemplate(){

				$this->isloggedin();

		$userdata=$this->session->userdata('log_in');	

	//	if($userdata[0]->user_role==1){

			if($this->input->post('submit')!='Submit'){

					$this->userlayout('users/addTemplate');

			}else{

					$data['template_name']=$this->input->post('template_name');

					$data['template_content']=$this->input->post('template_content');

					$this->form_validation->set_rules('template_name','template name','required|is_unique[templates.template_name]');

					if($this->form_validation->run() == FALSE){	

						$this->userlayout('users/addTemplate');

					}else{

						$res=$this->userModel->addTemplate($data);

						$this->session->set_flashdata('success', $res);

						redirect('/index.php/users/addtemplate');	

				}

			}

		/*}else{

			$this->session->set_flashdata('error', 'Only Admin can create user account.');

		}*/

			

			}

		public function alltemplate(){

					$this->isloggedin();

					$templates=$this->userModel->allTemplate();

					$this->data=array('templates'=>$templates);

					$this->userlayout('users/allTemplate');

			

			}
			
			
			
	public function sendemail(){
		$this->isloggedin();
		if($this->input->post('submit')!='Send e-mail'){
			$allsmtp=$this->userModel->getallsmtp();
			$templates=$this->userModel->allTemplate();
			$this->data=array('templates' =>$templates,'allsmtp'=>$allsmtp);
			$this->userlayout('users/sendemail');
		}else{
			
			if($_POST['pick']=='picktemp'){
				$data['emailaddresses']=$this->input->post('emailaddresses');
				$data['template']=$this->input->post('template');
				$data['subject']=$this->input->post('subject');
				
				$this->form_validation->set_rules('emailaddresses','emailaddresses','required');
				$this->form_validation->set_rules('template','template','required');
				$this->form_validation->set_rules('subject','subject','required');

				if($this->form_validation->run() == FALSE){	
					$templates=$this->userModel->allTemplate();
					$this->data=array('templates' =>$templates);
					$this->userlayout('users/sendemail');
				
				}else{
					$response=$this->userModel->sendemailhistory($data);
					if($response=='Error'){
						$this->session->set_flashdata('error', 'Error while processing.Please try again later or contact website administrator');
						redirect('/index.php/users/sendemail');	
					}else if($response=='Later'){
						$this->session->set_flashdata('success', 'Your message has been scheduled!');
						redirect('/index.php/users/sendemail');	
					}else{
						$gettemplatedetails = $this->userModel->gettemplatedetails($response['history_template']);
						
						if($_POST['mailprototype']=='php'){
							$getadminemail = $this->userModel->getadminemail();
							$this->email->from($getadminemail);
							$this->email->to($response['history_emaillist']);
							$this->email->subject($response['history_subject']);
							$this->email->message($gettemplatedetails[0]->template_content);
							$this->email->set_mailtype('html');
							$this->email->send();
						}else{ // smtp
							$getsettingsemail = $this->userModel->getSmtpDetails($_POST['mailprototype']);
						
							$config['protocol'] = 'smtp';
							$config['smtp_host'] = $getsettingsemail[0]->email_hostname;
							$config['smtp_port'] = $getsettingsemail[0]->email_port;
							$config['smtp_user'] =  $getsettingsemail[0]->email_username;
							$config['smtp_pass'] =  $getsettingsemail[0]->email_password;

							$this->load->library('email', $config);


							$this->email->from($getsettingsemail[0]->email_fromemail,$getsettingsemail[0]->email_fromname);
							
							$this->email->to($response['history_emaillist']);
							$this->email->subject($response['history_subject']);
							$this->email->message($gettemplatedetails[0]->template_content);
							$this->email->set_mailtype('html');							
							$this->email->send(); 
						}	
						$this->session->set_flashdata('success', 'Successfully sent emails!!');
						redirect('/index.php/users/sendemail');	
					}
					
				}
			
			}else{
				// template content
			
				$data['emailaddresses']=$this->input->post('emailaddresses');
				$data['template_content']=$this->input->post('template_content');
				$data['subject']=$this->input->post('subject');
				
				$this->form_validation->set_rules('emailaddresses','emailaddresses','required');
				$this->form_validation->set_rules('template_content','template_content','required');
				$this->form_validation->set_rules('subject','subject','required');

				if($this->form_validation->run() == FALSE){	
					$templates=$this->userModel->allTemplate();
					$this->data=array('templates' =>$templates);
					$this->userlayout('users/sendemail');
				
				}else{
					$data['template']=$this->input->post('template_content');
					$response=$this->userModel->sendemailhistory($data);
					if($response=='Error'){
						$this->session->set_flashdata('error', 'Error while processing.Please try again later or contact website administrator');
						redirect('/index.php/users/sendemail');	
					}else if($response=='Later'){
						$this->session->set_flashdata('success', 'Your message has been scheduled!');
						redirect('/index.php/users/sendemail');	
					}else{
						if($_POST['mailprototype']=='php'){
							$getadminemail = $this->userModel->getadminemail();
							$this->email->from($getadminemail);
							$this->email->to($response['history_emaillist']);
							$this->email->subject($response['history_subject']);
							$this->email->message($response['history_template']);
							$this->email->set_mailtype('html');
							$this->email->send();
						}else{
							
							$getsettingsemail = $this->userModel->getSmtpDetails($_POST['mailprototype']);
						
							$config['protocol'] = 'smtp';
							$config['smtp_host'] = $getsettingsemail[0]->email_hostname;
							$config['smtp_port'] = $getsettingsemail[0]->email_port;
							$config['smtp_user'] =  $getsettingsemail[0]->email_username;
							$config['smtp_pass'] =  $getsettingsemail[0]->email_password;

							$this->load->library('email', $config);


							$this->email->from($getsettingsemail[0]->email_fromemail,$getsettingsemail[0]->email_fromname);
							
							$this->email->to($response['history_emaillist']);
							$this->email->subject($response['history_subject']);
							$this->email->message($response['history_template']);
							$this->email->set_mailtype('html');
							$this->email->send(); 
							
						}
						$this->session->set_flashdata('success', 'Successfully sent emails!!');
						redirect('/index.php/users/sendemail');	
							
					}
				}
			}
		}
	}		
	
	
	
	public function sendemailbylist(){
			$this->isloggedin();
		if($this->input->post('submit')!='Send e-mail'){
			$groups=$this->userModel->allGroup();
			$allsmtp=$this->userModel->getallsmtp();
			$templates=$this->userModel->allTemplate();
			$this->data=array('groups' =>$groups,'templates' =>$templates,'allsmtp'=>$allsmtp);
			$this->userlayout('users/sendemailbylist');
		}else{
			if($_POST['pick']=='picktemp'){

						$data['group']=$this->input->post('group');
						$data['template']=$this->input->post('template');
						$data['subject']=$this->input->post('subject');
						
						//$this->form_validation->set_rules('group','group','required');
						$this->form_validation->set_rules('template','template','required');
						$this->form_validation->set_rules('subject','subject','required');

						if($this->form_validation->run() == FALSE){	
							$groups=$this->userModel->allGroup();
							$templates=$this->userModel->allTemplate();
							$this->data=array('groups' =>$groups,'templates' =>$templates);
							$this->userlayout('users/sendemailbylist');
						}else{
							$response=$this->userModel->sendemailhistorybylist($data);
							if($response=='Error'){
								$this->session->set_flashdata('error', 'Error while processing.Please try again later or contact website administrator');
								redirect('/index.php/users/sendemailbylist');	
							}else if($response=='Later'){
								$this->session->set_flashdata('success', 'Your message has been scheduled!');
								redirect('/index.php/users/sendemailbylist');	
							}else{
								if($_POST['mailprototype']=='php'){
									$gettemplatedetails = $this->userModel->gettemplatedetails($data['template']);
									
									$getadminemail = $this->userModel->getadminemail();
									$this->email->from($getadminemail);
							
									$this->email->to($response);
									$this->email->subject($data['subject']);
									$this->email->message($gettemplatedetails[0]->template_content);
									$this->email->set_mailtype('html');
									$this->email->send();
								}else{
										$getsettingsemail = $this->userModel->getSmtpDetails($_POST['mailprototype']);
						
										$config['protocol'] = 'smtp';
										$config['smtp_host'] = $getsettingsemail[0]->email_hostname;
										$config['smtp_port'] = $getsettingsemail[0]->email_port;
										$config['smtp_user'] =  $getsettingsemail[0]->email_username;
										$config['smtp_pass'] =  $getsettingsemail[0]->email_password;

										$this->load->library('email', $config);


										$this->email->from($getsettingsemail[0]->email_fromemail,$getsettingsemail[0]->email_fromname);
												
							
									$this->email->to($response['history_emaillist']);
									$this->email->subject($response['history_subject']);
									$this->email->message($gettemplatedetails[0]->template_content);
									$this->email->set_mailtype('html');
									$this->email->send(); 

								}
								$this->session->set_flashdata('success', 'Successfully sent emails!!');
								redirect('/index.php/users/sendemailbylist');	
							}
							
						}
			}else{
				// template content

						$data['group']=$this->input->post('group');
						$data['template']=$this->input->post('template_content');
						$data['subject']=$this->input->post('subject');
						
						//$this->form_validation->set_rules('group','group','required');
						$this->form_validation->set_rules('template','template','required');
						$this->form_validation->set_rules('subject','subject','required');

						if($this->form_validation->run() == FALSE){	
							$groups=$this->userModel->allGroup();
							$templates=$this->userModel->allTemplate();
							$this->data=array('groups' =>$groups,'templates' =>$templates);
							$this->userlayout('users/sendemailbylist');
							
						}else{
							$response=$this->userModel->sendemailhistorybylist($data);
							if($response=='Error'){
								$this->session->set_flashdata('error', 'Error while processing.Please try again later or contact website administrator');
								redirect('/index.php/users/sendemailbylist');	
							}else if($response=='Later'){
								$this->session->set_flashdata('success', 'Your message has been scheduled!');
								redirect('/index.php/users/sendemailbylist');
							}else{
								if($_POST['mailprototype']=='php'){
									$getadminemail = $this->userModel->getadminemail();
									$this->email->from($getadminemail);
							
							
									$this->email->to($response);
									$this->email->subject($data['subject']);
									$this->email->message($data['template']);
									$this->email->set_mailtype('html');
									$this->email->send();
								}else{

									$getsettingsemail = $this->userModel->getSmtpDetails($_POST['mailprototype']);
						
									$config['protocol'] = 'smtp';
									$config['smtp_host'] = $getsettingsemail[0]->email_hostname;
									$config['smtp_port'] = $getsettingsemail[0]->email_port;
									$config['smtp_user'] =  $getsettingsemail[0]->email_username;
									$config['smtp_pass'] =  $getsettingsemail[0]->email_password;

									$this->load->library('email', $config);


									$this->email->from($getsettingsemail[0]->email_fromemail,$getsettingsemail[0]->email_fromname);
							
							
									$this->email->to($response);
									$this->email->subject($data['subject']);
									$this->email->message($data['template']);
									$this->email->set_mailtype('html');
									$this->email->send(); 
								}	

								$this->session->set_flashdata('success', 'Successfully sent emails!!');

								redirect('/index.php/users/sendemailbylist');	
									
									
							}
							
						}

				
				
			}			
		}
	}	



		public function history(){
			$this->isloggedin();
			$history=$this->userModel->history();
			$this->data=array('history'=>$history);
			$this->userlayout('users/history');
		}

		
		public function edittemplate($id){
			$this->isloggedin();
			$userdata=$this->session->userdata('log_in');	
			if($this->input->post('submit')!='Submit'){
				$details = $this->userModel->gettemplatedetails($id);
				$this->data=array('details'=>$details,'id'=>$id);
				$this->userlayout('users/edittemplate');
			}else{
					$data['template_name']=$this->input->post('template_name');
					$data['template_content']=$this->input->post('template_content');
					$this->form_validation->set_rules('template_name','template name','required');
					if($this->form_validation->run() == FALSE){	
						$this->userlayout('users/edittemplate/'.$id);
					}else{

						$res=$this->userModel->editTemplate($data,$id);
						$this->session->set_flashdata('success', $res);
						redirect('/index.php/users/alltemplate');	
				}
			}
		}
		
		
		
		
	public function editemaillist($id){
		$this->isloggedin();
		$userdata=$this->session->userdata('log_in');	
		if($this->input->post('submit')!='Update'){
			$emails=$this->userModel->allemail_list($id);
			$group=$this->userModel->groupbyid($id);
			$this->data=array('emails' =>$emails,'group'=>$group);
			$this->userlayout('users/editemaillist');
		}else{
			$data['group_name']=$this->input->post('group_name');
			$data['emaillist_email']=$this->input->post('emaillist_email');
			$data['id']=$id;
			$this->form_validation->set_rules('group_name','Group Name','required');
			$this->form_validation->set_rules('emaillist_email','Email list','required');
			if($this->form_validation->run() == FALSE){	
				$emails=$this->userModel->allemail_list($id);
				$group=$this->userModel->groupbyid($id);
				$this->data=array('emails' =>$emails,'group'=>$group);
				$this->userlayout('users/editemaillist');
			}else{
				$res=$this->userModel->updateemailgroup($data);
				$this->session->set_flashdata('success','List has been updated successfully!!');
				redirect('/index.php/users/editemaillist/'.$id);	
			}
		}
	}	
	
	
	public function deleteemailist($id){
		$this->userModel->deleteemailist_group($id);
		$this->userModel->deleteemailist_list($id);
		$this->session->set_flashdata('success','List has been deleted successfully!!');
		redirect('/index.php/users/allemaillist');
	}
	
	public function editmedia($id){
		$this->isloggedin();
		$userdata=$this->session->userdata('log_in');	
		if($this->input->post('submit')!='Update'){
			$media=$this->userModel->getmediadetails($id);
			$this->data=array('media' =>$media);
			$this->userlayout('users/editmedia');
		}else{
			if(!empty($_FILES['media_file']['name'])){
				$config = array(
					'upload_path' =>"./uploads/",
					'allowed_types' => "gif|jpg|png|jpeg|pdf",
					'overwrite' => TRUE,
					'max_size' => "2048000", // Can be set to particular file size , here it is 2 MB(2048 Kb)
					'max_height' => "768",
					'max_width' => "1024"
				);	
				$this->load->library('upload', $config);

				if(!$this->upload->do_upload('media_file')){
					$error=array('error'=> $this->upload->display_errors());
					$this->session->set_flashdata('error',$error);
					redirect('/users/editmedia/'.$id);			
				}else{
					$data['media_title']=$this->input->post('media_title');
					$imgdata = array('upload_data' => $this->upload->data());
					$data['media_path']=$imgdata['upload_data']['file_name'];
				}
			}else{ // no uploading
					$media=$this->userModel->getmediadetails($id);
					$data['media_title']=$this->input->post('media_title');
					$data['media_path']=$media[0]->media_path;
			}
			$data['id']=$id;

			$res=$this->userModel->editmedia($data);
			$this->session->set_flashdata('success','Media has been updated successfully!!');
			redirect('/index.php/users/editmedia/'.$id);	
		}
	}
	
	
	public function deletemedia($id){
		$this->userModel->deletemedia($id);
		$this->session->set_flashdata('success','Media has been deleted successfully!!');
		redirect('/index.php/users/allmedia');
	}
	
	
	public function settingsemail(){
		$this->isloggedin();
		if($this->input->post('submit')!='Update'){
			$emailsetting=$this->userModel->getPHPEMAILsettings();
			$this->data=array('emailsetting' =>$emailsetting);
			$this->userlayout('/users/settingsemail');
		}else{
			$data['email_fromemail']=$this->input->post('email_fromemail');
			$data['email_fromname']=$this->input->post('email_fromname');
			
			$this->form_validation->set_rules('email_fromemail','From Email','required');
			$this->form_validation->set_rules('email_fromname','From Name','required');
			
			if($this->form_validation->run() == FALSE){	
				$emailsetting=$this->userModel->getPHPEMAILsettings();
				$this->data=array('emailsetting' =>$emailsetting);
				$this->userlayout('users/settingsemail');
			}else{
				$res=$this->userModel->updatePHPEMAILsettings($data);
				$this->session->set_flashdata('success','PHP Email settings has been updated successfully!!');
				redirect('/index.php/users/settingsemail');	
			}
		}
	}
	
	
	public function settingstheme(){
		$this->isloggedin();
		if($this->input->post('submit')!='Update'){
			$themesettings=$this->userModel->getsettingstheme();
			$this->data=array('themesettings' =>$themesettings);
			$this->userlayout('/users/settingstheme');
		}else{
			$data['theme_name']=$this->input->post('theme_name');
			$data['theme_email']=$this->input->post('theme_email');
			$data['theme_address']=$this->input->post('theme_address');
			$data['theme_language']=$this->input->post('theme_language');

			$this->form_validation->set_rules('theme_name','Site Name','required');
			$this->form_validation->set_rules('theme_email','Site Email','required');
			$this->form_validation->set_rules('theme_address','Address','required');
			$this->form_validation->set_rules('theme_language','Language','required');
			
			if($this->form_validation->run() == FALSE){	
				$emailsetting=$this->userModel->getsettingstheme();
				$this->data=array('themesettings' =>$themesettings);
				$this->userlayout('/users/settingstheme');
			}else{
				$res=$this->userModel->updatesettingstheme($data);
				$this->session->set_flashdata('success','Theme settings has been updated successfully!!');
				redirect('/index.php/users/settingstheme');	
			}
		} 
	}
	
	
	public function settingstranslation(){
		$this->isloggedin();
		if($this->input->post('submit')!='Add'){
			$alllanguages=$this->userModel->getalllanguages();
			$addedlanguages=$this->userModel->getalladdedlanguages();
			
			$this->data=array('alllanguages' =>$alllanguages,'addedlanguages'=>$addedlanguages);
			$this->userlayout('/users/settingstranslation');
		}else{
				$id=$this->input->post('addlan');
				$res=$this->userModel->addlanguage($id);
				if($res=='error'){
					$this->session->set_flashdata('error','This language already exist');
				}else{
					$this->session->set_flashdata('success','Language has been updated successfully!!');
				}
				redirect('/index.php/users/settingstranslation');	
		}
	}
	
	public function activatelan($id){
		$activatelan=$this->userModel->activatelan($id);
		$this->session->set_flashdata('success','Language has been activated successfully!!');
		redirect('/index.php/users/settingstranslation');	
	}
	
	public function deactivatelan($id){
		$activatelan=$this->userModel->deactivatelan($id);
		$this->session->set_flashdata('success','Language has been deactivates successfully!!');
		redirect('/index.php/users/settingstranslation');	

	}
	
	
	public function edittranslation($id){
		if($this->input->post('submit')!='Update'){
			$details = $this->userModel->gettransdetails($id);
			$this->data=array('id'=>$id,'details'=>$details);
			$this->userlayout('/users/edittranslation');
		}else{
			
		$arraytrans = array(0=>'Welcome',1=>'Dashboard',2=>'Users',3=>'Add User',4=>'All Users',5=>'Email List',6=>'Create Email List',7=>'All Email Lists',
			8=>'Template',9=>'Create Template',10=>'All Templates',11=>'Media',12=>'Add media',13=>'All media',14=>'Send Email',15=>'Send Email by Email List',
			16=>'History',17=>'All Activities',18=>'Settings',19=>'Email Setting',20=>'Theme Setting',21=>'Translation',22=>'Privacy & Terms',23=>'Database Backup',24=>'Log Out',25=>'Change Language',26=>'Full Name',27=>'Email',28=>'Password', 29=>'Add',30=>'E-mail',31=>'Role',32=>'Status',33=>'Action',34=>'Admin',35=>'Active',36=>'Add Email List',37=>'Group', 38=>'Emails', 39=>'Submit',40=>'Name',41=>'Email List Details',42=>'E-Mail Id',
			43=>'All Templates',44=>'Title',45=>'Add Template',46=>'Template Name',47=>'Template Content',48=>'Add Media',49=>'Title',50=>'Upload file',
			51=>'All Media',52=>'Image',53=>'Email Addresses',54=>'Send email by',55=>'Pick Template',56=>'Message Box',57=>'Template',58=>'Subject',
			59=>'Sender',60=>'E-mail list',61=>'Time',62=>'Email Settings',63=>'SMTP Host Name',64=>'SMTP Username',65=>'SMTP Password',66=>'SMTP Port',
			67=>'From Email',68=>'From Email Name',69=>'Theme Settings',70=>'Site Name', 71=>'Site Email Address',72=>'Address', 73=>'Language',
			74=>'Translation Settings',75=>'Edit User',76=>'Email List Details',77=>'Edit Media');	
			$data=array();
			for($a=0;$a<count($arraytrans);$a++){
				if($_POST['trans'][$a]==''){
					$data[$a]=$arraytrans[$a];	
				}else{
					$data[$a]=$_POST['trans'][$a];	
				}
			}
			$this->userModel->edittranslation($data,$id);
			$this->session->set_flashdata('success','Translation has been updated successfully!!');
			redirect('/index.php/users/edittranslation/'.$id);
		}
	}
	
	
	public function downloaddatabase(){
		$this->load->dbutil();
		$prefs = array('format'=>'zip','filename'=> 'my_db_backup.sql');
        $backup = $this->dbutil->backup($prefs); 
		$db_name = 'backup-on-'. date("Y-m-d-H-i-s") .'.zip';
		$this->load->helper('download');
        force_download($db_name, $backup); 
	}
	
	
	
	public function settingsprivacy(){
		
		$this->isloggedin();
		if($this->input->post('submitpri')=='Update'){
			$this->userModel->updateprivacy();
			$this->session->set_flashdata('success','Privacy has been updated successfully!!');
			redirect('/index.php/users/settingsprivacy/');
		}else if($this->input->post('submitterm')=='Update'){
			$this->userModel->updateterms();
			$this->session->set_flashdata('success','Terms & conditions has been updated successfully!!');
			redirect('/index.php/users/settingsprivacy/');
		}else{
			$this->data['settings'] = $this->userModel->getsettingstheme();
			$this->userlayout('/users/settingsprivacy');
		}	
	}
	

	
	
	
	
	public function lostpassword(){
		if($this->input->post('submit')=='Reset'){
			$return = $this->userModel->updatetoken();
			if($return===false){ //not found
				$this->session->set_flashdata('error',"This Email Id doesn't exist");
			}else{
				$getadminemail = $this->userModel->getadminemail();
				$this->email->from($getadminemail);
				$this->email->to($_POST['user_name']);
				$this->email->subject('Password Reset Request!');
				$this->email->message('Recently you have requested to reset your account password.Please use this passcode to reset your password. Passcode is '.$return.' Click <a href="'.base_url().'users/resetpassword">here</a> to reset password');
				$this->email->set_mailtype('html');
				$this->email->send();
				$this->session->set_flashdata('success','We have sent you email to reset your password.Please check.');
			}
			redirect('/index.php/users/lostpassword');
		}else{
			$this->load->view('users/lostpassword');
		}	

	}
	
	
	public function resetpassword(){
		if($this->input->post('submit')=='Reset'){
			$return = $this->userModel->resetpassword();
			if($return===false){ //not found
				$this->session->set_flashdata('error',"Incorrect Email id or Passcode");
				redirect('/index.php/users/resetpassword');
			}else{
				$this->session->set_flashdata('success','Your password has been successfully updated!');
				redirect('/index.php/users/login');
			}
		}else{
			$this->load->view('users/resetpassword');
		}	

	}
	
	
	public function changelanguage($id){
		$this->userModel->changelanguage($id);
		redirect('/index.php/users/dashboard');
	}
	
	
	public function createsmtp(){
		$this->isloggedin();
		$userdata=$this->session->userdata('log_in');	
			if($this->input->post('submit')!='Add'){
				$this->userlayout('users/createsmtp');
			}else{
				$data['email_name']=$this->input->post('email_name');
				$data['email_hostname']=$this->input->post('email_hostname');
				$data['email_username']=$this->input->post('email_username');
				$data['email_password']=$this->input->post('email_password');
				$data['email_fromemail']=$this->input->post('email_fromemail');
				$data['email_fromname']=$this->input->post('email_fromname');
				$data['email_port']=$this->input->post('email_port');
				

				$this->form_validation->set_rules('email_name','SMTP Name','required');
				$this->form_validation->set_rules('email_hostname','SMTP Hostname','required');
				$this->form_validation->set_rules('email_username','SMTP Username','required');
				$this->form_validation->set_rules('email_password','SMTP Password','required');
				$this->form_validation->set_rules('email_fromemail','SMTP From Email','required');
				$this->form_validation->set_rules('email_fromname','SMTP From Email Name','required');
				
				if($this->form_validation->run() == FALSE){	
					$this->userlayout('users/createsmtp');
				}else{
					$reg=$this->userModel->createsmtp($data);
					$this->session->set_flashdata('success', $reg);
					redirect('/index.php/users/createsmtp');	
				}
			}
	}
	
	
	public function allsmtp(){
		$this->isloggedin();
		$allsmtp=$this->userModel->getallsmtp();
		$this->data=array('allsmtp'=>$allsmtp);
		$this->userlayout('users/allsmtp');
	}
	
	
	public function editsmtp($id){
		$this->isloggedin();
		if($this->input->post('submit')!='Update'){
			$smtpdetails=$this->userModel->getSmtpDetails($id);
			$this->data=array('smtpdetails' =>$smtpdetails);
			$this->userlayout('users/editsmtp');
		}else{
			$data['email_name']=$this->input->post('email_name');
			$data['email_hostname']=$this->input->post('email_hostname');
			$data['email_username']=$this->input->post('email_username');
			$data['email_password']=$this->input->post('email_password');
			$data['email_fromemail']=$this->input->post('email_fromemail');
			$data['email_fromname']=$this->input->post('email_fromname');
			$data['email_port']=$this->input->post('email_port');
			

			$this->form_validation->set_rules('email_name','SMTP Name','required');
			$this->form_validation->set_rules('email_hostname','SMTP Hostname','required');
			$this->form_validation->set_rules('email_username','SMTP Username','required');
			$this->form_validation->set_rules('email_password','SMTP Password','required');
			$this->form_validation->set_rules('email_fromemail','SMTP From Email','required');
			$this->form_validation->set_rules('email_fromname','SMTP From Email Name','required');
			if($this->form_validation->run() == FALSE){
				$smtpdetails=$this->userModel->getSmtpDetails($id);
				$this->data=array('smtpdetails' =>$smtpdetails);
				$this->userlayout('users/editsmtp');
			}else{
				$reg=$this->userModel->updateSmtpSettings($data,$id);
				$this->session->set_flashdata('success','SMTP has been updated successfully!!');
				redirect('/index.php/users/editsmtp/'.$id);
			}
		}
	}
	
	
	
	public function deletesmtp($id){
		$del=$this->userModel->deletesmtp($id);
		if($del=true){
			$this->session->set_flashdata('success','SMTP has been deleted successfully!!');
			redirect('/index.php/users/allsmtp');
		}
	}
		
		
		
	public function cron(){
		$sendemaillater = $this->userModel->cron();
		
		for($a=0;$a<count($sendemaillater);$a++){
			if(is_numeric($sendemaillater[$a]->emaillater_template)){
				$gettemplatedetails = $this->userModel->gettemplatedetails($sendemaillater[$a]->emaillater_template);
				$this->email->message($gettemplatedetails[0]->template_content);
			}else{
				$this->email->message($sendemaillater[$a]->emaillater_template);
			}
									
			$getadminemail = $this->userModel->getadminemail();
			
			$this->email->from($getadminemail);
	 
			$this->email->to($sendemaillater[$a]->emaillater_emaillist);
			$this->email->subject($sendemaillater[$a]->emaillater_subject);
			$this->email->set_mailtype('html');
			$this->email->send();
		}
	}	

		
		
		
		
}